stages:
  - build & test
  - deploy

build:
  stage: build & test
  image: node:22
  script:
    - npm install
    - npm run build
  artifacts:
    paths:
      - dist

test:
  stage: build & test
  image: node:22
  script:
    - npm install
    - npm run test

deploy:
  stage: deploy
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  environment: production
  script:
    - aws s3 rm s3://mazerty.fr --recursive
    - aws s3 cp dist/ s3://mazerty.fr --recursive
    - aws cloudfront create-invalidation --distribution-id EKAQ945MRMDPZ --paths "/*"
  rules:
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
